<template>
  <div class="criterion-form-item">
    <!-- <div
      v-if="!!question.GroupName && (questionForm[question.ParentId] === question.ParentTriggerValue) || question.ParentId===''||question.ParentId===null"
      style="font-weight: bold;font-size: 16px;margin: 5px 0px;"
    >
      {{ question.GroupName }}
    </div> -->
    <div
      v-if="!!question.GroupName && question.Type==='group'"
      style="font-weight: bold;font-size: 16px;margin: 5px 0px;"
    >
      {{ question.GroupName }}
    </div>
    <div
      v-else-if="question.Type==='table' || question.Type==='basicTable'"
      style="font-weight: bold;font-size: 14px;margin: 5px 0px;"
    >
      {{ question.QuestionName }}
    </div> 
    <template v-else>
      <el-form-item
        v-if="(question.ShowQuestion===1 && question.ParentTriggerValueList.includes(String(questionForm[question.ParentId]))) || question.ShowQuestion===0"
        :label="`${question.QuestionName}`"
        :prop="question.Id"
        :rules="[
          { required: (question.IsRequired === 0 || (question.IsRequired ===1 && question.RelevanceId && question.RelevanceValueList.includes(questionForm[question.RelevanceId]))) && question.Type!=='group' && question.Type!=='summary',
            message: this.$t('common:ruleMessage:specify'), trigger: ['blur', 'change']},
        ]"
        :class="[question.Type==='group'?'mb':question.Type==='upload'?'uploadWrapper':'']"
      >
        <!-- 输入框 -->
        <el-input
          v-if="question.Type==='input'"
          v-model="questionForm[question.Id]"
          :disabled="question.TableQuestionType === 2"
        />
        <!-- 多行文本输入框 -->
        <el-input
          v-if="question.Type==='textarea'"
          v-model="questionForm[question.Id]"
          type="textarea"
          :autosize="{ minRows: 2, maxRows: 4}"
        />
        <!-- 下拉框 -->
        <el-select
          v-if="question.Type==='select'"
          v-model="questionForm[question.Id]"
          clearable
          :disabled="(question.TableQuestionType === 2 || question.QuestionGenre === 2) && !!question.DictionaryCode"
          @change="((val)=>{formItemChange(val, question)})"
        >
          <template v-if="question.TableQuestionType === 1">
            <el-option
              v-for="item in organList"
              :key="item.Id"
              :label="item[question.DataTableColumn]"
              :value="item[question.DataTableColumn]"
            />
          </template>

          <template v-else-if="question.DictionaryCode">
            <el-option
              v-for="item of $d[question.DictionaryCode]"
              :key="item.id"
              :value="item.value.toString()"
              :label="item.label"
            />
          </template>
          <!-- <template v-else-if="question.TableQuestionType === 3 || question.QuestionGenre === 3">
            <el-option
              v-for="item of $d[question.DictionaryCode]"
              :key="item.id"
              :value="item.value"
              :label="item.label"
            />
          </template> -->
          <template v-else-if="question.TypeValue">
            <el-option
              v-for="val in question.TypeValue.split('|')"
              :key="val"
              :label="val"
              :value="val"
            />
          </template>

        </el-select>
        <!-- 单选 -->
        <el-radio-group
          v-if="question.Type==='radio'"
          v-model="questionForm[question.Id]"
          @change="((val)=>{formItemChange(val, question)})"
        >
          <template v-if="question.DictionaryCode">
            <el-radio
              v-for="item of $d[question.DictionaryCode]"
              :key="item.id"
              :label="item.value.toString()"
            >
              {{ item.label }}
            </el-radio>
          </template>
          <template v-else-if="question.TypeValue">
            <el-radio
              v-for="val in question.TypeValue.split('|')"
              :key="val"
              :label="val"
            >
              {{ val }}
            </el-radio>
          </template>
        </el-radio-group>
        <!-- 复选框 -->
        <el-checkbox-group
          v-if="question.Type==='checkbox'"
          v-model="questionForm[question.Id]"
        >
          <el-checkbox
            v-for="val in question.TypeValue.split('|')"
            :key="val"
            :label="val"
          >
            {{ val }}
          </el-checkbox>
        </el-checkbox-group>

        <!-- 自动计算 -->
        <!-- :precision="2" :step="0.1" :max="10" -->
        <el-input
          v-if="question.Type==='calculation'"
          v-model="questionForm[question.Id]"
          disabled
        />
        <!-- 自增 -->
        <el-input
          v-if="question.Type==='increment'"
          v-model="questionForm[question.Id]"
          disabled
        />
        <!-- 数值 -->
        <!-- :precision="2" :step="0.1" :max="10" -->
        <!-- <el-input-number
          v-if="question.Type==='number'"
          v-model="questionForm[question.Id]"
        />  -->
        <el-input
          v-if="question.Type==='number'"
          v-model="questionForm[question.Id]"
          type="number"
          :disabled="question.DataSource === 1"
        >
          <template v-if="question.Unit" slot="append">{{$fd('ValueUnit', question.Unit)}}</template>
        </el-input>
        <!-- 自动分类 -->
        <el-input
          v-if="question.Type==='calss'"
          v-model="questionForm[question.Id]"
          disabled
        />
        <!-- 上传图像 -->
        <el-upload
          v-if="question.Type==='upload'"
          action
          :accept="question.FileType"
          :limit="question.ImageCount"
          :on-preview="handlePictureCardPreview"
          :before-upload="handleBeforeUpload"
          :http-request="uploadScreenshot"
          list-type="picture-card"
          :on-remove="handleRemove"
          :file-list="fileList"
          :class="{disabled:fileList.length >= question.ImageCount}"
        >
          <i slot="default" class="el-icon-plus" />
          <div slot="file" slot-scope="{file}">
            <img
              class="el-upload-list__item-thumbnail"
              :src="OSSclientConfig.basePath + file.url"
              crossorigin="anonymous"
              alt=""
            >
            <span class="el-upload-list__item-actions">
              <span
                class="el-upload-list__item-preview"
                @click="handlePictureCardPreview(file)"
              >
                <i class="el-icon-zoom-in" />
              </span>

              <span
                v-if="readingTaskState < 2"
                class="el-upload-list__item-delete"
                @click="handleRemove(file)"
              >
                <i class="el-icon-delete" />
              </span>
            </span>
          </div>
        </el-upload>
        <el-dialog
          v-if="question.Type==='upload'"
          append-to-body
          :visible.sync="imgVisible"
          width="600px"
        >
          <el-image :src="imageUrl" width="100%">
            <div slot="placeholder" class="image-slot">
              加载中<span class="dot">...</span>
            </div>
          </el-image>
        </el-dialog>
      </el-form-item>
    </template>

    <template v-if="question.Childrens && question.Childrens.length>0">
      <CriterionFormItem
        v-for="(item) in question.Childrens"
        :key="item.Id"
        :question="item"
        :reading-task-state="readingTaskState"
        :question-form="questionForm"
        :visit-task-id="visitTaskId"
        :criterion-id="criterionId"
        @setFormItemData="setFormItemData"
        @resetFormItemData="resetFormItemData"
      />
    </template>

  </div>
</template>
<script>
import { uploadReadingAnswerImage } from '@/api/trials'
import { getOrganInfoList } from '@/api/dictionary'
export default {
  name: 'CriterionFormItem',
  props: {
    questionForm: {
      type: Object,
      default() {
        return {}
      }
    },
    question: {
      type: Object,
      default() {
        return []
      }
    },
    criterionId: {
      type: String,
      required: true
    },
    readingTaskState: {
      type: Number,
      required: true
    },
    visitTaskId: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      fileList: [],
      accept: '.png,.jpg,.jpeg',
      imgVisible: false,
      imageUrl: '',
      urls: [],
      organList: []
    }
  },
  watch: {
    questionForm: {
      deep: true,
      immediate: true,
      handler(v) {
        // console.log(v)
      }
    }
  },
  mounted() {
    if (this.question.Type === 'upload') {
      if (this.questionForm[this.question.Id]) {
        this.urls = this.questionForm[this.question.Id].split('|')
        this.fileList = []

        this.urls.map(url => {
          this.fileList.push({ name: '', url: `${url}` })
        })
      }
    }
    if (this.question.TableQuestionType === 1 && this.question.LesionType !== null) {
      this.getOrganInfoList()
    }
  },
  methods: {
    getOrganInfoList() {
      var param = {
        lesionType: this.question.LesionType,
        systemCriterionId: this.criterionId
      }
      getOrganInfoList(param).then(res => {
        this.organList = res.Result
      })
    },
    formItemChange(v, question) {
      if (question.Childrens.length > 0) {
        this.resetChild(question.Childrens)
      }
      if (question.TableQuestionType === 1 && question.RelationQuestions.length > 0) {
        var index = this.organList.findIndex(item => item[question.DataTableColumn] === v)
        if (index < 0) return
        var selected = this.organList[index]
        this.question.RelationQuestions.map(qs => {
          var val = selected[qs.DataTableColumn]
          // if (typeof val === 'boolean') {
          //   // val = String(val)
          // }

          this.$emit('setFormItemData', { key: qs.Id, val: val })
        })
      }
    },
    resetChild(obj) {
      obj.forEach(i => {
        this.$emit('resetFormItemData', i.Id)
        if (i.Childrens && i.Childrens.length > 0) {
          this.resetChild(i.Childrens)
        }
      })
    },
    resetFormItemData(v) {
      this.$emit('resetFormItemData', v)
    },
    setFormItemData(obj) {
      this.$emit('setFormItemData', obj)
    },
    async uploadScreenshot(param) {
      if (!this.visitTaskId) return
      const loading = this.$loading({
        target: document.querySelector('.ecrf-wrapper'),
        fullscreen: false,
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading'
      })
      const formData = new FormData()
      formData.append('file', param.file)
      var file = await this.fileToBlob(param.file)
      const res = await this.OSSclient.put(`/${this.trialId}/ReadAttachment/${this.subjectId}/${this.visitTaskId}/${param.file.name}`, file)
      this.fileList.push({ name: param.file.name, url: this.$getObjectName(res.url) })
      this.urls.push(this.$getObjectName(res.url))
      this.$emit('setFormItemData', { key: this.question.Id, val: this.urls.length > 0 ? this.urls.join('|') : '' })
      loading.close()
    },
    handleBeforeUpload(file) {
      // 检测文件类型是否符合要求
      console.log(file.name)
      console.log(this.checkFileSuffix(file.name))
      if (this.checkFileSuffix(file.name)) {
        // this.fileList = []
        return true
      } else {
        this.$alert(`必须是 ${this.accept} 格式`)
        return false
      }
    },
    checkFileSuffix(fileName) {
      var index = fileName.lastIndexOf('.')
      var suffix = fileName.substring(index + 1, fileName.length)
      if (this.accept.toLocaleLowerCase().search(suffix.toLocaleLowerCase()) === -1) {
        return false
      } else {
        return true
      }
    },
    // 预览图片
    handlePictureCardPreview(file) {
      this.imageUrl = this.OSSclientConfig.basePath + file.url
      this.imgVisible = true
    },
    // 删除图片
    handleRemove(file, fileList) {
      this.imageUrl = ''
      this.fileList.splice(this.fileList.findIndex(f => f.url === file.url), 1)
      this.urls.splice(this.fileList.findIndex(f => f === file.url), 1)
      this.$emit('setFormItemData', { key: this.question.Id, val: this.urls.length > 0 ? this.urls.join('|') : '' })
    }
  }
}
</script>
<style lang="scss" scoped>
.criterion-form-item{
  .el-form-item{
    display: flex;
    flex-direction: row;
    align-items: flex-start;
  }
  ::v-deep .el-form-item__content{
    width: 500px;
  }
  .el-input{
    width:100%;
  }
.mb{
  margin-bottom: 0px;
}
.disabled{
  ::v-deep .el-upload--picture-card {
    display: none;
  }
}
.uploadWrapper{
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}
}
</style>
